/* Code von Peter Danneger http://www.mikrocontroller.net/topic/174303#1672233 */

#include<avr/io.h>
#include <util/delay.h>
#include "mydefs.h"
#include "main.h"
#include "lcd_drv.h"
#include "Xmega_IO_bits_definition.h"

//#define PINF PORTF
#define PINF PORTF.IN
//#define	TASTER0 0 
//#define	TASTER1 1
//#define	PF4 4
//#define	PF7 7

/******************************************************************************/

#define debounce( port, pin )						\
({									\
  static uint8_t flag = 0;	/* new variable on every macro usage */	\
  uint8_t i = 0;							\
									\
  if( flag ){			/* check for key release: */		\
    for(;;){			/* loop ... */				\
      if( !(port & 1<<pin) ){	/* ... until key pressed or ... */	\
	i = 0;			/* 0 = bounce */			\
	break;								\
      }									\
      _delay_us( 98 );		/* * 256 = 25ms */			\
      if( --i == 0 ){		/* ... until key >25ms released */	\
	flag = 0;		/* clear press flag */			\
	i = 0;			/* 0 = key release debounced */		\
	break;								\
      }									\
    }									\
  }else{			/* else check for key press: */		\
    for(;;){			/* loop ... */				\
      if( (port & 1<<pin) ){	/* ... until key released or ... */	\
	i = 0;			/* 0 = bounce */			\
	break;								\
      }									\
      _delay_us( 98 );		/* * 256 = 25ms */			\
      if( --i == 0 ){		/* ... until key >25ms pressed */	\
	flag = 1;		/* set press flag */			\
	i = 1;			/* 1 = key press debounced */		\
	break;								\
      }									\
    }									\
  }									\
  i;				/* return value of Macro */		\
})

/******************************************************************************/


int main( void )
{
  
   PORTD_DIR=0xff;      //Initialise port
   PORTD_OUT=0xff;      //All leds off, negative logic
   
   PORTE_DIR=0xff;      //Initialise port
   PORTE_OUT=0xff;      //All leds off, negative logic
    
   PORTF_DIR=0x00;      //Initialise port
   PORTCFG.MPCMASK=0xFF; //Fr alle Bits wird die Multiportmaske gesetzt
   PORTF.PIN0CTRL=0x38; // Fr alle Pins von PORTE Wired-AND-Pull Up--> 0x38 Bits 3,4,5 von "Pin n Configuration Register" auf 1
						// 011 --> 0x18 tambien seria posible Pagina 142 Xmega A Manual
						
  lcd_init();
  // 1 Zeile 0,0  /2 Zeile 0,40 /3 Zeile 0,20 /4 Zeile 3,0
  
      while(1)
    {
		lcd_pos( 0, 0 ); // Zeile 1 
		lcd_text( (u8*)"Erste  1234567891234" );
		lcd_pos( 0, 20 );
		lcd_text( (u8*)"Dritte 1234567891234" );
		lcd_pos( 0, 40 );
		lcd_text( (u8*)"Zweite 1234567891234" );
		lcd_pos( 3, 0 );
		lcd_text( (u8*)"Vierte 1234567891234" );
		
			if (debounce(PINF, PF1))
				{
				lcd_clear();
				lcd_pos( 0, 0 ); // Zeile 1 
				lcd_text( (u8*)"Erste" );
				PORTE_OUT = 0x03; // -->> para probar con LED's si funciona
				lcd_pos( 0, 20 ); // Zeile 2 
				lcd_text( (u8*)"Dritte" );
				PORTE_OUT = 0x07;
				_delay_ms( 300 );
				lcd_clear();
				lcd_pos( 0, 40 ); // Zeile 1 
				lcd_text( (u8*)"Zweite" );
				PORTE_OUT = 0x0F;
				_delay_ms( 300 );
				lcd_pos( 3, 60 ); // Zeile 4
				lcd_clear();
				lcd_text( (u8*)"Vierte" );
				PORTE_OUT = 0x1F;
				_delay_ms( 300 );
				lcd_clear();
				lcd_pos( 0, 0 ); // Zeile 1 
				lcd_text( (u8*)"Getrenk bitte" );
				lcd_pos( 0, 60 ); // Zeile 2 
				lcd_text( (u8*)"--> entnehmen" );
				PORTE_OUT = 0x3F;
				_delay_ms( 300 );
				lcd_clear();
				}
			if (debounce(PINF, PF2))
				{
				lcd_clear();
				lcd_pos( 0, 0 ); // Zeile 1 
				lcd_text( (u8*)"Apfelschorle" );
				lcd_pos( 3, 0 ); // Zeile 2 
				lcd_text( (u8*)"2 Euro" );
				_delay_ms( 300 );
				lcd_clear();
				lcd_pos( 4, 0 ); // Zeile 1 
				lcd_text( (u8*)"Bitte warten..." );
				_delay_ms( 300 );
				lcd_clear();
				lcd_pos( 0, 0 ); // Zeile 1 
				lcd_text( (u8*)"Getrenk bitte" );
				lcd_pos( 1, 1 ); // Zeile 2 
				lcd_text( (u8*)"--> entnehmen" );
				_delay_ms( 300 );
				lcd_clear();
				}
			if (debounce(PINF, PF3))
				{
				lcd_clear();
				lcd_pos( 0, 0 ); // Zeile 1 
				lcd_text( (u8*)"Vienetta" );
				lcd_pos( 1, 0 ); // Zeile 2 
				lcd_text( (u8*)"0,85 Euro" );
				_delay_ms( 300 );
				lcd_clear();
				lcd_pos( 0, 0 ); // Zeile 1 
				lcd_text( (u8*)"Bitte warten..." );
				_delay_ms( 300 );
				lcd_clear();
				lcd_pos( 0, 0 ); // Zeile 1 
				lcd_text( (u8*)"Getrenk bitte" );
				lcd_pos( 1, 1 ); // Zeile 2 
				lcd_text( (u8*)"--> entnehmen" );
				_delay_ms( 300 );
				lcd_clear();
				}

    }
 
    return 0;
  
  
}
